"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const os_1 = __importDefault(require("os"));
const script = __importStar(require("@script-string/core"));
const language_1 = __importDefault(require("./language"));
const runner = {
    useStdIn: true,
    extension: '.ps1',
    command: {
        bin: os_1.default.platform() === 'win32' ? 'powershell.exe' : 'pwsh',
        common: ['-NoProfile'],
        stdin: ['-Command', '-'],
        file: ['-File']
    }
};
const params = [
    ['args', 'ScriptArguments', []]
];
const args = 'ScriptArguments';
class PSScript extends script.Builder {
    constructor(strings, values, options) {
        super(strings, values, {
            name: 'powershell',
            language: language_1.default,
            runner,
            params,
            args,
            ...options
        });
    }
    *_foot() {
        // powershell -Command - needs the extra lines at the end to correctly
        // excute multi lines scripts
        yield '\n\n';
    }
}
const powershell = script.define(['powershell', 'pwsh'], PSScript);
exports.default = powershell;
